#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

constexpr int MAXN = 1000;
constexpr int MAXM = 1000;

int n, m;
vector<int> notes;
bool is[MAXN][MAXM];

int main() {
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        while (k-->0) {
            int l;
            cin >> l;
            is[i][l] = true;
        }
    }
    for (int i = 0; i < m; i++) {
        int l;
        cin >> l;
        notes.push_back(l);
    }

    int note = 0;
    int res = 0;
    while (note < m) {
        int cp = -1; 
        for (int j = 0; j < n; j++) {
            int lcp = 0;
            for (int k = note; k < m && is[j][notes[k]]; k++)
                lcp++;
            cp = max(cp, lcp);
        }
        note += cp;
        res++;
    }

    cout << res-1 << endl;
}

