#include <cstdio>
#include <queue>

struct fm{
	long long nbuy, perkg;
	fm(long long nbuy, long long perkg) : nbuy(nbuy), perkg(perkg) {}
	friend bool operator<(const fm &l, const fm &r){
		return l.perkg < r.perkg;
	}
};

int main(){
	long long fish, fishmongers, f, n, kg;
	scanf("%lld %lld", &fish, &fishmongers);
	std::priority_queue<long long> fishes;
	std::priority_queue<fm> fmongers;

	while(fish--){
		scanf("%lld", &f);
		fishes.push(f);
	}

	while(fishmongers--){
		scanf("%lld %lld", &n, &kg);
		fmongers.emplace(n,kg);
	}

	unsigned long long monies = 0;
	while(!fishes.empty() && !fmongers.empty()){
		kg = fmongers.top().perkg;
		n = fmongers.top().nbuy;
		fmongers.pop();

		while(n-- && !fishes.empty()){	
			monies += (long)kg * (long)fishes.top();
			fishes.pop();
		}

	}
	printf("%llu\n", monies);
	return 0;
}
