#!/usr/bin/env python3

def fish():
    n, m = [int(x) for x in input().split()]
    fish = sorted([int(x) for x in input().split()])
    shops = sorted([[int(x) for x in input().split()] for _ in range(m)], key= lambda x: x[1])
    
    earnings = 0
    while len(fish) > 0 and len(shops) > 0:
        weight = fish.pop()
        earnings += weight * shops[-1][1]
        shops[-1][0] -= 1
        if shops[-1][0] == 0:
            shops.pop()
    
    return earnings
    
    
print(fish())