import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.*;

public class InstrumentTrouble {

    public static void main(String args[]) throws Exception {
        Input in = new Input();
        int n = in.nextInt();
        int m = in.nextInt();
        boolean instruments[][] = new boolean[n][1001];
        for (int i = 0; i < n; i++){
            int k = in.nextInt();
            for (int j = 0; j < k; j++){
                instruments[i][in.nextInt()] = true;
            }
        }

        TreeSet<Integer> valid = new TreeSet<>();
        for (int i = 0; i < n; i++) valid.add(i);
        int res = 1;
        for (int i = 0; i < m; i++){
            Integer note = in.nextInt();
            ArrayList<Integer> toremove = new ArrayList<>();
            for (Integer j: valid)
                if (!instruments[j][note])
                    toremove.add(j);
            for (Integer j: toremove)
                valid.remove(j);
            if (valid.size() == 0){
                res++;
                for (int j = 0; j < n; j++) valid.add(j);
                toremove = new ArrayList<>();
                for (Integer j: valid)
                    if (!instruments[j][note])
                        toremove.add(j);
                for (Integer j: toremove)
                    valid.remove(j);
            }
        }

        System.out.println(res-1);
    }

    static class Input{
        StringTokenizer st;
        BufferedReader br;

        Input(){
            st = new StringTokenizer("");
            br = new BufferedReader(new InputStreamReader(System.in));
        }

        int nextInt() throws Exception{
            while (!st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
            return Integer.parseInt(st.nextToken());
        }

        long nextLong() throws Exception{
            while (!st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
            return Long.parseLong(st.nextToken());
        }

        double nextDouble() throws Exception{
            while (!st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
            return Double.parseDouble(st.nextToken());
        }

        String nextToken() throws Exception{
            while (!st.hasMoreTokens()) st = new StringTokenizer(br.readLine());
            return st.nextToken();
        }
    }
}
